GNU bug report logs - #37829
27.0.50; Overlay behaviour changed without documentation.

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Zhu Zihao <all_but_last@HIDDEN>; dated Sun, 20 Oct 2019 09:53:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 21 Oct 2019 19:43:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 21 15:43:15 2019
Received: from localhost ([127.0.0.1]:57873 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iMdaE-0003RU-Nx
	for submit <at> debbugs.gnu.org; Mon, 21 Oct 2019 15:43:14 -0400
Received: from quimby.gnus.org ([80.91.231.51]:51184)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iMdaB-0003RK-7k
 for 37829 <at> debbugs.gnu.org; Mon, 21 Oct 2019 15:43:11 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iMda5-0003xT-Ur; Mon, 21 Oct 2019 21:43:08 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#37829: 27.0.50; Overlay behaviour changed without
 documentation.
References: <87d0erssxl.wl-all_but_last@HIDDEN> <83mudv65jd.fsf@HIDDEN>
 <87tv83fz0n.fsf@HIDDEN> <83h843644k.fsf@HIDDEN>
 <87blubfxq9.fsf@HIDDEN> <83d0er62y7.fsf@HIDDEN>
 <87ftjne50s.fsf@HIDDEN> <83o8yb44d6.fsf@HIDDEN>
Date: Mon, 21 Oct 2019 21:43:05 +0200
In-Reply-To: <83o8yb44d6.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 20 Oct
 2019 22:13:41 +0300")
Message-ID: <87eez5q3zq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > But under the
 assumption
 that most faces should not be extended, that > would mean our default is
 wrong in most cases, and what kind of > default is that? I agree that it's
 a bad default, but changing it now is going to require that a lot of people
 is going to have to change their code. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 37829
Cc: 37829 <at> debbugs.gnu.org, all_but_last@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> But under the assumption that most faces should not be extended, that
> would mean our default is wrong in most cases, and what kind of
> default is that?

I agree that it's a bad default, but changing it now is going to require
that a lot of people is going to have to change their code.

>> And there certainly aren't unlimited places we have to change thing
>> in-tree, because most things in-tree look just how we wanted them to.
>
> I said "including those not in core".

We don't have to change things not in core.

I'm for not changing defaults like this unnecessarily.  And it is
unnecessary -- things work for people now (because they've adapted to
the behaviour), and having the default be the established behaviour
wouldn't limit the usability of the feature.

But I'm going to stop arguing about this now, because we're just
restating our arguments.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 19:15:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 15:15:39 2019
Received: from localhost ([127.0.0.1]:55293 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iMGfz-0002UX-5k
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 15:15:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:36874)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iMGfx-0002UK-1d
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 15:15:37 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52115)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iMGfr-0003sE-Tg; Sun, 20 Oct 2019 15:15:31 -0400
Received: from [176.228.60.248] (port=1605 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iMGfq-0001kV-QG; Sun, 20 Oct 2019 15:15:31 -0400
Date: Sun, 20 Oct 2019 22:15:23 +0300
Message-Id: <83mudv44ac.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Zhu Zihao <all_but_last@HIDDEN>
In-reply-to: <87k18zjsx1.wl-all_but_last@HIDDEN> (message from Zhu Zihao on
 Mon, 21 Oct 2019 00:14:18 +0800)
Subject: Re: bug#37829: 27.0.50;
 Overlay behaviour changed without documentation.
References: <87d0erssxl.wl-all_but_last@HIDDEN>
 <83mudv65jd.fsf@HIDDEN> <87k18zjsx1.wl-all_but_last@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 37829
Cc: 37829 <at> debbugs.gnu.org, all_but_last@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Mon, 21 Oct 2019 00:14:18 +0800
> From: Zhu Zihao <all_but_last@HIDDEN>
> Cc: Zhu Zihao <all_but_last@HIDDEN>,
> 	37829 <at> debbugs.gnu.org
> 
> 
> I'm puzzled that we already have :extend, but when I set the end of an overlay
> to the EOL, the face of overlay still don't cover the whole line.

The position you use as the end of the overlay is one position after
the end of the text that is affected by the overlay.  Remember: in
Emacs, a buffer position is between two characters.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 19:13:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 15:13:59 2019
Received: from localhost ([127.0.0.1]:55289 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iMGeM-0002RK-N1
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 15:13:58 -0400
Received: from eggs.gnu.org ([209.51.188.92]:36663)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iMGeK-0002R3-Gh
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 15:13:56 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52095)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iMGeD-00038p-Oi; Sun, 20 Oct 2019 15:13:49 -0400
Received: from [176.228.60.248] (port=1503 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iMGeD-0001bo-0i; Sun, 20 Oct 2019 15:13:49 -0400
Date: Sun, 20 Oct 2019 22:13:41 +0300
Message-Id: <83o8yb44d6.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <87ftjne50s.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 20 Oct 2019 18:49:23 +0200)
Subject: Re: bug#37829: 27.0.50; Overlay behaviour changed without
 documentation.
References: <87d0erssxl.wl-all_but_last@HIDDEN> <83mudv65jd.fsf@HIDDEN>
 <87tv83fz0n.fsf@HIDDEN> <83h843644k.fsf@HIDDEN>
 <87blubfxq9.fsf@HIDDEN> <83d0er62y7.fsf@HIDDEN> <87ftjne50s.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 37829
Cc: 37829 <at> debbugs.gnu.org, all_but_last@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: all_but_last@HIDDEN,  37829 <at> debbugs.gnu.org
> Date: Sun, 20 Oct 2019 18:49:23 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > The idea behind this feature was that most faces shall not be
> > extended, so doing it the opposite way would mean we need to change
> > the definitions of an unlimited number of faces, including those not
> > in core.
> 
> We do not have to change anything not in core -- whether people want the
> new, more convenient behaviour, is up to them.

But under the assumption that most faces should not be extended, that
would mean our default is wrong in most cases, and what kind of
default is that?

> And there certainly aren't unlimited places we have to change thing
> in-tree, because most things in-tree look just how we wanted them to.

I said "including those not in core".

> > Others said the exact opposite: that they want to be able to do that
> > without having the face extended.
> 
> With the new interface, they can do that, whatever the default is.

They wanted to do that without customizing the faces.

> > Also, the automatic extension in Emacs 26 and before behaved
> > inconsistently in GUI and text-mode frames, and even between different
> > attributes (color vs underline, for example).
> 
> Well, the only attributes where it makes a difference are background
> colours and underline, surely?  (Well, and overline, but nobody uses
> that.)

No, there's also strikethrough and box.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 17:37:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 13:37:02 2019
Received: from localhost ([127.0.0.1]:55231 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iMF8Y-000094-5u
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 13:37:02 -0400
Received: from mail-m973.mail.163.com ([123.126.97.3]:54918)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <all_but_last@HIDDEN>) id 1iMDqq-0006aI-PM
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 12:14:43 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=163.com;
 s=s110527; h=Date:Message-ID:From:Subject:MIME-Version; bh=oFcW1
 sXCc+LZCpgVSfeshltE4Z2Gpe/TIx38WajQYTw=; b=N4mIq9vuLk6aJfhCVeQtK
 /dsXQccTDdE4c2AzprmjuynhgRB3N/n5juWjxtRAsczgN8WuHL3VpyuGIehsYjgm
 D9pKsDSqtTlBBRxdzpl81qZCcbqfTpcrPL8SgazB8QzGNuRKpMR/Ww4ZFzHDWQ27
 TIO7daE/SE2DWrj91cjY1E=
Received: from archlinux.163.com (unknown [112.93.132.134])
 by smtp3 (Coremail) with SMTP id G9xpCgCXn6vch6xdYjc8FA--.21S2;
 Mon, 21 Oct 2019 00:14:32 +0800 (CST)
Date: Mon, 21 Oct 2019 00:14:18 +0800
Message-ID: <87k18zjsx1.wl-all_but_last@HIDDEN>
From: Zhu Zihao <all_but_last@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#37829: 27.0.50;
 Overlay behaviour changed without documentation.
In-Reply-To: <83mudv65jd.fsf@HIDDEN>
References: <87d0erssxl.wl-all_but_last@HIDDEN>
	<83mudv65jd.fsf@HIDDEN>
User-Agent: Wanderlust/2.15.9 (Almost Unreal) SEMI-EPG/1.14.7 (Harue)
 FLIM/1.14.9 (=?ISO-8859-4?Q?Goj=F2?=) APEL/10.8 EasyPG/1.0.0 Emacs/27.0
 (x86_64-pc-linux-gnu) MULE/6.0 (HANACHIRUSATO)
X-Face: :]]%@R1{oDt0%iKgI@Kga#OZ;
 ogt+%OOne&J4#E*O,TIlI)yEFw--I\:3<fJY!NX#[Lq,{w
 f=2H*=S(); L<qZt!Sg$b/}B-}&y{(co7MDpqhkXejrL%_NB\C&<mKCfot91?1a'oJ/gD?t"4j<KfQ3
 {`_N@$o^.ETrMMk:p>s~EV97GI$1.1!}8inmF9UgtUBB@#8>'8NWNC8qg/v*OLfQB; Z:@G3HeNf3u&
 ,&HpBGv%?p{bzsl'|5T";1&X
MIME-Version: 1.0 (generated by SEMI-EPG 1.14.7 - "Harue")
Content-Type: text/plain; charset=US-ASCII
X-CM-TRANSID: G9xpCgCXn6vch6xdYjc8FA--.21S2
X-Coremail-Antispam: 1Uf129KBjDUn29KB7ZKAUJUUUUU529EdanIXcx71UUUUU7v73
 VFW2AGmfu7bjvjm3AaLaJ3UbIYCTnIWIevJa73UjIFyTuYvj4RJSdyDUUUU
X-Originating-IP: [112.93.132.134]
X-CM-SenderInfo: pdoosuxxwbztlvw6il2tof0z/1tbiKQhUr1XltnPkswAAs4
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 37829
X-Mailman-Approved-At: Sun, 20 Oct 2019 13:36:57 -0400
Cc: 37829 <at> debbugs.gnu.org, Zhu Zihao <all_but_last@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


I'm puzzled that we already have :extend, but when I set the end of an overlay
to the EOL, the face of overlay still don't cover the whole line.

I have to set it to the BOL of next line.

If I understand correctly, :extend already mark a face extends EOL, why we still
need old method to make it take effect?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 17:37:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 13:37:02 2019
Received: from localhost ([127.0.0.1]:55229 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iMF8U-00008u-Vr
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 13:37:00 -0400
Received: from mail-m971.mail.163.com ([123.126.97.1]:34644)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <all_but_last@HIDDEN>) id 1iM9R0-0007Ms-PT
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 07:31:45 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=163.com;
 s=s110527; h=Date:Message-ID:From:Subject:MIME-Version; bh=pdslc
 zcl2GzQguMEcX3hZpX9H9HSnwHv4uxool3Kwm0=; b=k7TYRSIb+X3nNShl8HB6K
 kerugDA6briK5rixDtnOJXW7/mWiwum8ktT73RjMS4Wkbo0fSMJJQDXzFqWxxL+Z
 aTRqmYrOHXIvrEva0OJkDeN6sQ7sa+ibJW9xpg2jlkJqUkH+N/7qMqEMQsnAP4c9
 GlyrRmnbhA0EVDrqJsP01Y=
Received: from archlinux.163.com (unknown [112.93.132.134])
 by smtp1 (Coremail) with SMTP id GdxpCgD3ymV4RaxdzoS3JA--.7S2;
 Sun, 20 Oct 2019 19:31:36 +0800 (CST)
Date: Sun, 20 Oct 2019 19:31:03 +0800
Message-ID: <87sgnnirgo.wl-all_but_last@HIDDEN>
From: Zhu Zihao <all_but_last@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#37829: 27.0.50;
 Overlay behaviour changed without documentation.
In-Reply-To: <83mudv65jd.fsf@HIDDEN>
References: <87d0erssxl.wl-all_but_last@HIDDEN>
	<83mudv65jd.fsf@HIDDEN>
User-Agent: Wanderlust/2.15.9 (Almost Unreal) SEMI-EPG/1.14.7 (Harue)
 FLIM/1.14.9 (=?ISO-8859-4?Q?Goj=F2?=) APEL/10.8 EasyPG/1.0.0 Emacs/27.0
 (x86_64-pc-linux-gnu) MULE/6.0 (HANACHIRUSATO)
X-Face: :]]%@R1{oDt0%iKgI@Kga#OZ;
 ogt+%OOne&J4#E*O,TIlI)yEFw--I\:3<fJY!NX#[Lq,{w
 f=2H*=S(); L<qZt!Sg$b/}B-}&y{(co7MDpqhkXejrL%_NB\C&<mKCfot91?1a'oJ/gD?t"4j<KfQ3
 {`_N@$o^.ETrMMk:p>s~EV97GI$1.1!}8inmF9UgtUBB@#8>'8NWNC8qg/v*OLfQB; Z:@G3HeNf3u&
 ,&HpBGv%?p{bzsl'|5T";1&X
MIME-Version: 1.0 (generated by SEMI-EPG 1.14.7 - "Harue")
Content-Type: text/plain; charset=US-ASCII
X-CM-TRANSID: GdxpCgD3ymV4RaxdzoS3JA--.7S2
X-Coremail-Antispam: 1Uf129KBjvdXoWruF1fKryfAw4ftr4xWrW8tFb_yoWfGrX_ua
 1vvrykJ3yUZFyxXF4jkrs8Jr95AFn7uFy5AFy7Jwn7uFySq3y3uF1qgr9Yvw129FsYq3yD
 ur1jqFy5Wr15CjkaLaAFLSUrUUUUUb8apTn2vfkv8UJUUUU8Yxn0WfASr-VFAUDa7-sFnT
 9fnUUvcSsGvfC2KfnxnUUI43ZEXa7xRNsqXJUUUUU==
X-Originating-IP: [112.93.132.134]
X-CM-SenderInfo: pdoosuxxwbztlvw6il2tof0z/1tbiFBhUr1aD3NfMJAAAsB
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 37829
X-Mailman-Approved-At: Sun, 20 Oct 2019 13:36:57 -0400
Cc: 37829 <at> debbugs.gnu.org, Zhu Zihao <all_but_last@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sun, 20 Oct 2019 19:05:26 +0800,
Eli Zaretskii wrote:
> 
> > Date: Sun, 20 Oct 2019 16:49:10 +0800
> > From: Zhu Zihao <all_but_last@HIDDEN>
> > 
> > 1. open a empty buffer, type "Lorem ipsum" in it, then goto point-min
> > 2. Eval this code
> > 
> > (let ((ov (make-overlay (point-min) (1+ (point-at-eol)))))
> >   (overlay-put ov 'face 'mode-line))
> > 
> > In current version of Emacs, the mode line overlay will only cover the string
> > "Lorem ipsum", but in 26.2, the overlay will cover the hole line(every pixel in
> > line).
> > 
> > It may be a bug because no documentation or NEWS mentioned this change.
> 
> Crystal ball says it's because the mode-line face doesn't have the
> :extend attribute by default.  If so, this change _is_ in NEWS and in
> the ELisp manual.
> 
> Thanks.

Thanks, I just search "overlay" in NEWS so I didn't notice it's the issue of
face, not the overlay.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 16:49:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 12:49:31 2019
Received: from localhost ([127.0.0.1]:55198 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iMEOY-0007Rf-Ut
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 12:49:31 -0400
Received: from quimby.gnus.org ([80.91.231.51]:51750)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iMEOX-0007RX-Mc
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 12:49:30 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iMEOR-0001Db-Vg; Sun, 20 Oct 2019 18:49:26 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#37829: 27.0.50; Overlay behaviour changed without
 documentation.
References: <87d0erssxl.wl-all_but_last@HIDDEN> <83mudv65jd.fsf@HIDDEN>
 <87tv83fz0n.fsf@HIDDEN> <83h843644k.fsf@HIDDEN>
 <87blubfxq9.fsf@HIDDEN> <83d0er62y7.fsf@HIDDEN>
Date: Sun, 20 Oct 2019 18:49:23 +0200
In-Reply-To: <83d0er62y7.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 20 Oct
 2019 15:01:20 +0300")
Message-ID: <87ftjne50s.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > The idea behind this
 feature was that most faces shall not be > extended, so doing it the opposite
 way would mean we need to change > the definitions of an unlimited number
 of faces, including those [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 37829
Cc: 37829 <at> debbugs.gnu.org, all_but_last@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> The idea behind this feature was that most faces shall not be
> extended, so doing it the opposite way would mean we need to change
> the definitions of an unlimited number of faces, including those not
> in core.

We do not have to change anything not in core -- whether people want the
new, more convenient behaviour, is up to them.

And there certainly aren't unlimited places we have to change thing
in-tree, because most things in-tree look just how we wanted them to.

> I suggest to run with it for some time, you may change your mind.  It
> happened to many of us.

I know that the new interface is convenient -- I'll be able to ditch a
bunch of code in shr that works around the problem.  But that's just
it -- this is what everybody has done forever, and have ended up with
code that does exactly what they want it to.  (I.e., placing a face on
newline to extend the face to the end of the line.)

>> We do that because that's the way we wanted the display to look.  If we
>> didn't want that, we didn't put the face on the newline.  
>
> Others said the exact opposite: that they want to be able to do that
> without having the face extended.

With the new interface, they can do that, whatever the default is.  The
question is whether Emacs should do this massive, extremely user-visible
(with very ugly results) thing by default.

I think no.

> Also, the automatic extension in Emacs 26 and before behaved
> inconsistently in GUI and text-mode frames, and even between different
> attributes (color vs underline, for example).

Well, the only attributes where it makes a difference are background
colours and underline, surely?  (Well, and overline, but nobody uses
that.)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 12:01:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 08:01:41 2019
Received: from localhost ([127.0.0.1]:53964 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iM9u1-0000I7-A6
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 08:01:41 -0400
Received: from eggs.gnu.org ([209.51.188.92]:58475)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iM9tz-0000Hu-4u
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 08:01:39 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47453)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iM9tr-0006dT-CI; Sun, 20 Oct 2019 08:01:31 -0400
Received: from [176.228.60.248] (port=2124 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iM9tp-0007rE-Me; Sun, 20 Oct 2019 08:01:30 -0400
Date: Sun, 20 Oct 2019 15:01:20 +0300
Message-Id: <83d0er62y7.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <87blubfxq9.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 20 Oct 2019 13:43:58 +0200)
Subject: Re: bug#37829: 27.0.50; Overlay behaviour changed without
 documentation.
References: <87d0erssxl.wl-all_but_last@HIDDEN> <83mudv65jd.fsf@HIDDEN>
 <87tv83fz0n.fsf@HIDDEN> <83h843644k.fsf@HIDDEN> <87blubfxq9.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 37829
Cc: 37829 <at> debbugs.gnu.org, all_but_last@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: all_but_last@HIDDEN,  37829 <at> debbugs.gnu.org
> Date: Sun, 20 Oct 2019 13:43:58 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > And doing this the opposite way makes no sense to me, it's in effect
> > the same as removing the feature.
> 
> I don't understand.  Doing it the opposite way would be just as
> expressive.

The idea behind this feature was that most faces shall not be
extended, so doing it the opposite way would mean we need to change
the definitions of an unlimited number of faces, including those not
in core.

> > > This change breaks a lot of out-of-tree code.
> >
> > No, it doesn't break any code.  It changes how display looks in some
> > cases, so people are surprised at first.
> 
> You may quibble, but changing the look this radically is breaking the
> code for me.

I suggest to run with it for some time, you may change your mind.  It
happened to many of us.

> > For this particular bug report, why would someone expect the overlay's
> > color to extend to the end of the line instead of affecting only the
> > text that the overlay covers?
> 
> Because that's the way Emacs has worked since forever: If you put a face
> on a newline, then it'll extend to the end of the line.

We considered that a side effect of the implementation.  Many other
applications don't do that.

> We do that because that's the way we wanted the display to look.  If we
> didn't want that, we didn't put the face on the newline.  

Others said the exact opposite: that they want to be able to do that
without having the face extended.  Also, the automatic extension in
Emacs 26 and before behaved inconsistently in GUI and text-mode
frames, and even between different attributes (color vs underline, for
example).





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 11:44:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 07:44:06 2019
Received: from localhost ([127.0.0.1]:53945 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iM9d0-0008H0-Gl
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 07:44:06 -0400
Received: from quimby.gnus.org ([80.91.231.51]:46308)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iM9cx-0008Gq-6U
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 07:44:05 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iM9cs-0006ne-TF; Sun, 20 Oct 2019 13:44:01 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#37829: 27.0.50; Overlay behaviour changed without
 documentation.
References: <87d0erssxl.wl-all_but_last@HIDDEN> <83mudv65jd.fsf@HIDDEN>
 <87tv83fz0n.fsf@HIDDEN> <83h843644k.fsf@HIDDEN>
Date: Sun, 20 Oct 2019 13:43:58 +0200
In-Reply-To: <83h843644k.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 20 Oct
 2019 14:35:55 +0300")
Message-ID: <87blubfxq9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > And doing this the
 opposite way makes no sense to me, it's in effect > the same as removing the
 feature. I don't understand. Doing it the opposite way would be just as
 expressive.
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 37829
Cc: 37829 <at> debbugs.gnu.org, all_but_last@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> And doing this the opposite way makes no sense to me, it's in effect
> the same as removing the feature.

I don't understand.  Doing it the opposite way would be just as
expressive.

> > This change breaks a lot of out-of-tree code.
>
> No, it doesn't break any code.  It changes how display looks in some
> cases, so people are surprised at first.

You may quibble, but changing the look this radically is breaking the
code for me.

> For this particular bug report, why would someone expect the overlay's
> color to extend to the end of the line instead of affecting only the
> text that the overlay covers?

Because that's the way Emacs has worked since forever: If you put a face
on a newline, then it'll extend to the end of the line.

We do that because that's the way we wanted the display to look.  If we
didn't want that, we didn't put the face on the newline.  

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 11:36:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 07:36:15 2019
Received: from localhost ([127.0.0.1]:53932 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iM9VP-00085C-0a
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 07:36:15 -0400
Received: from eggs.gnu.org ([209.51.188.92]:56751)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iM9VM-00084x-PV
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 07:36:13 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47250)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iM9VG-0005Zs-Ai; Sun, 20 Oct 2019 07:36:06 -0400
Received: from [176.228.60.248] (port=4542 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iM9VE-0006YA-4N; Sun, 20 Oct 2019 07:36:05 -0400
Date: Sun, 20 Oct 2019 14:35:55 +0300
Message-Id: <83h843644k.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <87tv83fz0n.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 20 Oct 2019 13:16:08 +0200)
Subject: Re: bug#37829: 27.0.50; Overlay behaviour changed without
 documentation.
References: <87d0erssxl.wl-all_but_last@HIDDEN> <83mudv65jd.fsf@HIDDEN>
 <87tv83fz0n.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 37829
Cc: 37829 <at> debbugs.gnu.org, all_but_last@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Zhu Zihao <all_but_last@HIDDEN>,  37829 <at> debbugs.gnu.org
> Date: Sun, 20 Oct 2019 13:16:08 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Crystal ball says it's because the mode-line face doesn't have the
> > :extend attribute by default.  If so, this change _is_ in NEWS and in
> > the ELisp manual.
> 
> Hasn't there been sufficient fallout now from this change that we should
> consider doing the :extend stuff the opposite way?

No, I don't think so.  All the complaints until now were about Diff
mode and related modes, and we made the relevant faces extend a few
hours ago.  At least in one case, this change allowed to _remove_ some
kludgey code (in info.el).

And doing this the opposite way makes no sense to me, it's in effect
the same as removing the feature.

> This change breaks a lot of out-of-tree code.

No, it doesn't break any code.  It changes how display looks in some
cases, so people are surprised at first.

For this particular bug report, why would someone expect the overlay's
color to extend to the end of the line instead of affecting only the
text that the overlay covers?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 11:16:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 07:16:17 2019
Received: from localhost ([127.0.0.1]:53903 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iM9C4-0004fO-NM
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 07:16:16 -0400
Received: from quimby.gnus.org ([80.91.231.51]:45858)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iM9C1-0004cB-7I
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 07:16:14 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iM9Bx-0006Wo-9Z; Sun, 20 Oct 2019 13:16:11 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#37829: 27.0.50; Overlay behaviour changed without
 documentation.
References: <87d0erssxl.wl-all_but_last@HIDDEN> <83mudv65jd.fsf@HIDDEN>
Date: Sun, 20 Oct 2019 13:16:08 +0200
In-Reply-To: <83mudv65jd.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 20 Oct
 2019 14:05:26 +0300")
Message-ID: <87tv83fz0n.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > Crystal ball says it's
 because the mode-line face doesn't have the > :extend attribute by default.
 If so, this change _is_ in NEWS and in > the ELisp manual. Hasn't there been
 sufficient fallout now from this change that we should consider doing the
 :extend stuff the opposite way? That is, default to the old behaviour, and
 if we want certain faces not to e [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 37829
Cc: 37829 <at> debbugs.gnu.org, Zhu Zihao <all_but_last@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Crystal ball says it's because the mode-line face doesn't have the
> :extend attribute by default.  If so, this change _is_ in NEWS and in
> the ELisp manual.

Hasn't there been sufficient fallout now from this change that we should
consider doing the :extend stuff the opposite way?  That is, default to
the old behaviour, and if we want certain faces not to extend, then we
put in :extend nil on those faces.

This change breaks a lot of out-of-tree code.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at 37829 <at> debbugs.gnu.org:


Received: (at 37829) by debbugs.gnu.org; 20 Oct 2019 11:05:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 07:05:44 2019
Received: from localhost ([127.0.0.1]:53867 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iM91r-0003BL-Oo
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 07:05:44 -0400
Received: from eggs.gnu.org ([209.51.188.92]:54480)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iM91r-0003B8-1x
 for 37829 <at> debbugs.gnu.org; Sun, 20 Oct 2019 07:05:43 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47010)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iM91l-0001bJ-B9; Sun, 20 Oct 2019 07:05:37 -0400
Received: from [176.228.60.248] (port=2493 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iM91i-00044H-Mr; Sun, 20 Oct 2019 07:05:36 -0400
Date: Sun, 20 Oct 2019 14:05:26 +0300
Message-Id: <83mudv65jd.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Zhu Zihao <all_but_last@HIDDEN>
In-reply-to: <87d0erssxl.wl-all_but_last@HIDDEN> (message from Zhu Zihao on
 Sun, 20 Oct 2019 16:49:10 +0800)
Subject: Re: bug#37829: 27.0.50;
 Overlay behaviour changed without documentation.
References: <87d0erssxl.wl-all_but_last@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 37829
Cc: 37829 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Sun, 20 Oct 2019 16:49:10 +0800
> From: Zhu Zihao <all_but_last@HIDDEN>
> 
> 1. open a empty buffer, type "Lorem ipsum" in it, then goto point-min
> 2. Eval this code
> 
> (let ((ov (make-overlay (point-min) (1+ (point-at-eol)))))
>   (overlay-put ov 'face 'mode-line))
> 
> In current version of Emacs, the mode line overlay will only cover the string
> "Lorem ipsum", but in 26.2, the overlay will cover the hole line(every pixel in
> line).
> 
> It may be a bug because no documentation or NEWS mentioned this change.

Crystal ball says it's because the mode-line face doesn't have the
:extend attribute by default.  If so, this change _is_ in NEWS and in
the ELisp manual.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Oct 2019 09:52:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 20 05:52:18 2019
Received: from localhost ([127.0.0.1]:53796 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iM7sl-0005Vi-JX
	for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 05:52:18 -0400
Received: from lists.gnu.org ([209.51.188.17]:59665)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <all_but_last@HIDDEN>) id 1iM78z-0002J6-Fs
 for submit <at> debbugs.gnu.org; Sun, 20 Oct 2019 05:04:59 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:57108)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <all_but_last@HIDDEN>) id 1iM78w-0000O4-BB
 for bug-gnu-emacs@HIDDEN; Sun, 20 Oct 2019 05:04:57 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: **
X-Spam-Status: No, score=2.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 RCVD_IN_DNSWL_NONE,SPOOFED_FREEMAIL,URIBL_BLOCKED autolearn=disabled
 version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <all_but_last@HIDDEN>) id 1iM78q-0004gN-UE
 for bug-gnu-emacs@HIDDEN; Sun, 20 Oct 2019 05:04:51 -0400
Received: from mail-m973.mail.163.com ([123.126.97.3]:47058)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <all_but_last@HIDDEN>) id 1iM78p-0004ZK-HN
 for bug-gnu-emacs@HIDDEN; Sun, 20 Oct 2019 05:04:48 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=163.com;
 s=s110527; h=Date:Message-ID:From:Subject:MIME-Version; bh=h2a60
 rH+TD8rTSzVj9XoFr1JhH80BamaF1pSHoT4YIE=; b=DR9C/R1DjAyAuek/y1jp9
 7odDlTUrPa2twZYW+NrhlJhO62aMBCoyM1JpzREefe1ilVUWFnhCQkQ9s3cXAJbC
 ZUPe2qY/62VPqwAwE7K4xlwkNgfZaC4BMlW8SGElI5tJLWdcgPnCG00hH3i6PXcu
 /dKU/p7dKUgMpKyy1LTUow=
Received: from archlinux.163.com (unknown [112.93.132.134])
 by smtp3 (Coremail) with SMTP id G9xpCgDXTfyIH6xdntP7Ew--.68S2;
 Sun, 20 Oct 2019 16:49:25 +0800 (CST)
Date: Sun, 20 Oct 2019 16:49:10 +0800
Message-ID: <87d0erssxl.wl-all_but_last@HIDDEN>
From: Zhu Zihao <all_but_last@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 27.0.50; Overlay behaviour changed without documentation.
User-Agent: Wanderlust/2.15.9 (Almost Unreal) SEMI-EPG/1.14.7 (Harue)
 FLIM/1.14.9 (=?ISO-8859-4?Q?Goj=F2?=) APEL/10.8 EasyPG/1.0.0 Emacs/27.0
 (x86_64-pc-linux-gnu) MULE/6.0 (HANACHIRUSATO)
X-Face: :]]%@R1{oDt0%iKgI@Kga#OZ;
 ogt+%OOne&J4#E*O,TIlI)yEFw--I\:3<fJY!NX#[Lq,{w
 f=2H*=S(); L<qZt!Sg$b/}B-}&y{(co7MDpqhkXejrL%_NB\C&<mKCfot91?1a'oJ/gD?t"4j<KfQ3
 {`_N@$o^.ETrMMk:p>s~EV97GI$1.1!}8inmF9UgtUBB@#8>'8NWNC8qg/v*OLfQB; Z:@G3HeNf3u&
 ,&HpBGv%?p{bzsl'|5T";1&X
MIME-Version: 1.0 (generated by SEMI-EPG 1.14.7 - "Harue")
Content-Type: text/plain; charset=US-ASCII
X-CM-TRANSID: G9xpCgDXTfyIH6xdntP7Ew--.68S2
X-Coremail-Antispam: 1Uf129KBjvdXoWrZr17Gw15uw17Zw1kKrWxWFg_yoW3CrXE9w
 4vqrn3CayUXrWFqF4UZrs8Ar98GF1DCr15JryIqryI9a4aq39xZF929rZ8Jr9Fyrn3X39x
 WrsIqFyrKr18CjkaLaAFLSUrUUUUUb8apTn2vfkv8UJUUUU8Yxn0WfASr-VFAUDa7-sFnT
 9fnUUvcSsGvfC2KfnxnUUI43ZEXa7IU0BRRtUUUUU==
X-Originating-IP: [112.93.132.134]
X-CM-SenderInfo: pdoosuxxwbztlvw6il2tof0z/xtbBLxVUr1UMLyr6AAAAsn
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x [fuzzy]
X-Received-From: 123.126.97.3
X-Spam-Score: 0.6 (/)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Sun, 20 Oct 2019 05:52:14 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)


Reproduce step:

1. open a empty buffer, type "Lorem ipsum" in it, then goto point-min
2. Eval this code

(let ((ov (make-overlay (point-min) (1+ (point-at-eol)))))
  (overlay-put ov 'face 'mode-line))

In current version of Emacs, the mode line overlay will only cover the string
"Lorem ipsum", but in 26.2, the overlay will cover the hole line(every pixel in
line).

It may be a bug because no documentation or NEWS mentioned this change.

In GNU Emacs 27.0.50 (build 11, x86_64-pc-linux-gnu, GTK+ Version 3.24.12, cairo version 1.17.3)
 of 2019-10-20 built on archlinux
Repository revision: cea9577b7d6fcf01599afd48078f8ff1defb1297
Repository branch: makepkg
Windowing system distributor 'The X.Org Foundation', version 11.0.12005000
System Description: Arch Linux





Acknowledgement sent to Zhu Zihao <all_but_last@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#37829; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 21 Oct 2019 19:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.